/* ***********************************************************
 * This file was automatically generated on 2016-02-10.      *
 *                                                           *
 * LabVIEW Bindings Version 2.1.8                            *
 *                                                           *
 * If you have a bugfix for this file and want to commit it, *
 * please fix the bug in the generator. You can find a link  *
 * to the generators git repository on tinkerforge.com       *
 *************************************************************/

using System;

namespace Tinkerforge
{
	/// <summary>
	///  Battery-backed real-time clock
	/// </summary>
	public class BrickletRealTimeClock : Device
	{
		/// <summary>
		///  Used to identify this device type in
		///  <see cref="Tinkerforge.IPConnection.EnumerateCallback"/>.
		/// </summary>
		public static int DEVICE_IDENTIFIER = 268;

		/// <summary>
		///  The display name of this device.
		/// </summary>
		public static string DEVICE_DISPLAY_NAME = "Real-Time Clock Bricklet";

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.Device.GetResponseExpected"/>,
		///  <see cref="Tinkerforge.Device.SetResponseExpected"/> and
		///  <see cref="Tinkerforge.Device.SetResponseExpectedAll"/>.
		/// </summary>
		public const byte FUNCTION_SET_DATE_TIME = 1;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.Device.GetResponseExpected"/>,
		///  <see cref="Tinkerforge.Device.SetResponseExpected"/> and
		///  <see cref="Tinkerforge.Device.SetResponseExpectedAll"/>.
		/// </summary>
		public const byte FUNCTION_GET_DATE_TIME = 2;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.Device.GetResponseExpected"/>,
		///  <see cref="Tinkerforge.Device.SetResponseExpected"/> and
		///  <see cref="Tinkerforge.Device.SetResponseExpectedAll"/>.
		/// </summary>
		public const byte FUNCTION_GET_TIMESTAMP = 3;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.Device.GetResponseExpected"/>,
		///  <see cref="Tinkerforge.Device.SetResponseExpected"/> and
		///  <see cref="Tinkerforge.Device.SetResponseExpectedAll"/>.
		/// </summary>
		public const byte FUNCTION_SET_OFFSET = 4;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.Device.GetResponseExpected"/>,
		///  <see cref="Tinkerforge.Device.SetResponseExpected"/> and
		///  <see cref="Tinkerforge.Device.SetResponseExpectedAll"/>.
		/// </summary>
		public const byte FUNCTION_GET_OFFSET = 5;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.Device.GetResponseExpected"/>,
		///  <see cref="Tinkerforge.Device.SetResponseExpected"/> and
		///  <see cref="Tinkerforge.Device.SetResponseExpectedAll"/>.
		/// </summary>
		public const byte FUNCTION_GET_IDENTITY = 255;


		/// <summary>
		/// </summary>
		public const byte WEEKDAY_MONDAY = 1;

		/// <summary>
		/// </summary>
		public const byte WEEKDAY_TUESDAY = 2;

		/// <summary>
		/// </summary>
		public const byte WEEKDAY_WEDNESDAY = 3;

		/// <summary>
		/// </summary>
		public const byte WEEKDAY_THURSDAY = 4;

		/// <summary>
		/// </summary>
		public const byte WEEKDAY_FRIDAY = 5;

		/// <summary>
		/// </summary>
		public const byte WEEKDAY_SATURDAY = 6;

		/// <summary>
		/// </summary>
		public const byte WEEKDAY_SUNDAY = 7;


		/// <summary>
		///  Creates an object with the unique device ID <c>uid</c> and adds  it to
		///  the IPConnection <c>ipcon</c>.
		/// </summary>
		public BrickletRealTimeClock(string uid, IPConnection ipcon) : base(uid, ipcon)
		{
			this.apiVersion[0] = 2;
			this.apiVersion[1] = 0;
			this.apiVersion[2] = 0;


			responseExpected[FUNCTION_SET_DATE_TIME] = ResponseExpectedFlag.FALSE;
			responseExpected[FUNCTION_GET_DATE_TIME] = ResponseExpectedFlag.ALWAYS_TRUE;
			responseExpected[FUNCTION_GET_TIMESTAMP] = ResponseExpectedFlag.ALWAYS_TRUE;
			responseExpected[FUNCTION_SET_OFFSET] = ResponseExpectedFlag.FALSE;
			responseExpected[FUNCTION_GET_OFFSET] = ResponseExpectedFlag.ALWAYS_TRUE;
			responseExpected[FUNCTION_GET_IDENTITY] = ResponseExpectedFlag.ALWAYS_TRUE;
		}

		/// <summary>
		///  Sets the current date (including weekday) and the current time with hundredths
		///  of a second resolution.
		///  
		///  Possible value ranges:
		///  
		///  * Year: 2000 to 2099
		///  * Month: 1 to 12 (January to December)
		///  * Day: 1 to 31
		///  * Hour: 0 to 23
		///  * Minute: 0 to 59
		///  * Second: 0 to 59
		///  * Centisecond: 0 to 99
		///  * Weekday: 1 to 7 (Monday to Sunday)
		///  
		///  If the backup battery is installed then the real-time clock keeps date and
		///  time even if the Bricklet is not powered by a Brick.
		///  
		///  The real-time clock handles leap year and inserts the 29th of February
		///  accordingly. But leap seconds, time zones and daylight saving time are not
		///  handled.
		/// </summary>
		public void SetDateTime(int year, byte month, byte day, byte hour, byte minute, byte second, byte centisecond, byte weekday)
		{
			byte[] request = CreateRequestPacket(17, FUNCTION_SET_DATE_TIME);
			LEConverter.To((short)year, 8, request);
			LEConverter.To((byte)month, 10, request);
			LEConverter.To((byte)day, 11, request);
			LEConverter.To((byte)hour, 12, request);
			LEConverter.To((byte)minute, 13, request);
			LEConverter.To((byte)second, 14, request);
			LEConverter.To((byte)centisecond, 15, request);
			LEConverter.To((byte)weekday, 16, request);

			SendRequest(request);

		}

		/// <summary>
		///  Returns the current date (including weekday) and the current time of the
		///  real-time clock with hundredths of a second resolution.
		/// </summary>
		public void GetDateTime(out int year, out byte month, out byte day, out byte hour, out byte minute, out byte second, out byte centisecond, out byte weekday)
		{
			byte[] request = CreateRequestPacket(8, FUNCTION_GET_DATE_TIME);

			byte[] response = SendRequest(request);

			year = LEConverter.UShortFrom(8, response);
			month = LEConverter.ByteFrom(10, response);
			day = LEConverter.ByteFrom(11, response);
			hour = LEConverter.ByteFrom(12, response);
			minute = LEConverter.ByteFrom(13, response);
			second = LEConverter.ByteFrom(14, response);
			centisecond = LEConverter.ByteFrom(15, response);
			weekday = LEConverter.ByteFrom(16, response);
		}

		/// <summary>
		///  Returns the current date and the time of the real-time clock converted to
		///  milliseconds. The timestamp has an effective resolution of hundredths of a
		///  second.
		/// </summary>
		public long GetTimestamp()
		{
			byte[] request = CreateRequestPacket(8, FUNCTION_GET_TIMESTAMP);

			byte[] response = SendRequest(request);

			return LEConverter.LongFrom(8, response);
		}

		/// <summary>
		///  Sets the offset the real-time clock should compensate for in 2.17 ppm steps
		///  between -277.76 ppm (-128) and +275.59 ppm (127).
		///  
		///  The real-time clock time can deviate from the actual time due to the frequency
		///  deviation of its 32.768 kHz crystal. Even without compensation (factory
		///  default) the resulting time deviation should be at most ±20 ppm (±52.6
		///  seconds per month).
		///  
		///  This deviation can be calculated by comparing the same duration measured by the
		///  real-time clock (``rtc_duration``) an accurate reference clock
		///  (``ref_duration``).
		///  
		///  For best results the configured offset should be set to 0 ppm first and then a
		///  duration of at least 6 hours should be measured.
		///  
		///  The new offset (``new_offset``) can be calculated from the currently configured
		///  offset (``current_offset``) and the measured durations as follow::
		///  
		///    new_offset = current_offset - round(1000000 * (rtc_duration - ref_duration) / rtc_duration / 2.17)
		///  
		///  If you want to calculate the offset, then we recommend using the calibration
		///  dialog in Brick Viewer, instead of doing it manually.
		///  
		///  The offset is saved in the EEPROM of the Bricklet and only needs to be
		///  configured once.
		/// </summary>
		public void SetOffset(short offset)
		{
			byte[] request = CreateRequestPacket(9, FUNCTION_SET_OFFSET);
			LEConverter.To((byte)offset, 8, request);

			SendRequest(request);

		}

		/// <summary>
		///  Returns the offset as set by <see cref="Tinkerforge.BrickletRealTimeClock.SetOffset"/>.
		/// </summary>
		public short GetOffset()
		{
			byte[] request = CreateRequestPacket(8, FUNCTION_GET_OFFSET);

			byte[] response = SendRequest(request);

			return LEConverter.SByteFrom(8, response);
		}

		/// <summary>
		///  Returns the UID, the UID where the Bricklet is connected to, 
		///  the position, the hardware and firmware version as well as the
		///  device identifier.
		///  
		///  The position can be 'a', 'b', 'c' or 'd'.
		///  
		///  The device identifier numbers can be found :ref:`here &lt;device_identifier&gt;`.
		///  |device_identifier_constant|
		/// </summary>
		public override void GetIdentity(out string uid, out string connectedUid, out char position, out byte[] hardwareVersion, out byte[] firmwareVersion, out int deviceIdentifier)
		{
			byte[] request = CreateRequestPacket(8, FUNCTION_GET_IDENTITY);

			byte[] response = SendRequest(request);

			uid = LEConverter.StringFrom(8, response, 8);
			connectedUid = LEConverter.StringFrom(16, response, 8);
			position = LEConverter.CharFrom(24, response);
			hardwareVersion = LEConverter.ByteArrayFrom(25, response, 3);
			firmwareVersion = LEConverter.ByteArrayFrom(28, response, 3);
			deviceIdentifier = LEConverter.UShortFrom(31, response);
		}
	}
}
